main {
	padding-top: 2.5rem;
}

.testimonial {
	/* al asignar propiedades de tipo em aquí lo que se hará es multiplicar esos em por el valor
	que envie el navegador, por defecto se usa la letra mediana donde un em son 16px, si se aumenta
	o disminuye el tamaño de la fuente en las preferencias del navegador, esta letra aumentará o disminuirá su tamañ
	de forma dinámica, esto nos ayuda mejor que usar valores absolutes como pixeles, donde aumentar o disminuir el tamaño 
	de la letra del navegador no tiene ningun impacto */
	/* font-size: 1.2em; */
	font-size: 1.2rem;
	/* margin: 48px 0; */
	/* cambiamos los pixeles por rem, de este modo hacemos que los margenes dependan tambien
	del tamaño de la fuente del navegador y esto agrega más dinamismo, entre mas grande la fuente mas
	grandes los margenes */
	/* margin: 3rem 0; */
	padding: 0 10px;
	/* hacemos el elemento inline, de este modo el ancho de testimonial image, hace referencia no a este elemento
	si no al ancestro de este elemento que tenga una propiedad de display de bloque */
	/* display: inline; */
}

/* .testimonial__list {
	width: 80%;
	margin: auto;
} */

/* .testimonial:first-of-type { */
/* margin-top: 96px; */
/* hacemos la conversion de pixeles a rems para mantener la concordancia
	con los cambios de arriba donde se convirtieron pixeles a rem para margenes */
/* margin-top: 6rem; */
/* } */

.testimonial__image-container {
	/* si ponemos 100% hará referencia al 100% del ancestro sin contar los paddings
	por lo tanto este 100% no rebasará los límites del viewport (a menos que el ancestro lo haga) */
	/* width: 100%; */
	/* disminuimos el ancho total de nuestro contenedor de imagen para que se pueda apreciar completamente
	el contenedor ya con el skew aplicado */
	width: 60%;
	/* width: 65%; */
	/* min-width: 350px; */
	/* podemos usar las propiedades max-width y min-width, en combinación con valores porcentuales
	en este caso estamos usando un ancho porcentual lo que hará que nuestro ancho se ajuste al 65% del contenedor
	pero usamos max-width como si fuera un límite por lo tanto llegado a esa medida, de 580px en este caso
	la imagen dejará de crecer, esto es útil para por ejemplo en tamaños de pantalla muy grandes donde no necesariameente
	se requiera que el contenedor sea gigante.
	 */
	max-width: 40rem;
	/* si tenemos un valor de medida porcentual y nuestro elemento tiene position ya sea relative o static (
		static es el valor por defecto) el valor porcentual hará referencia al elemento ancestro más cercano
		que sea un elemento de bloque, es decir que no sea inline, en este caso es el padre directo de este elemento
		que es un div, a menos que lo hagamos inline como hacemos en este ejemplo, en este caso no se considera 
		los paddings, solamente el valor del contenido por lo tanto este 50% que ponemos aqui
		hace referencia al ancho del contenido del ancestro, sin contar sus paddings */
	/* width: 50%; */
	position: relative;
	/* inline block para que la imagen hija se ajuste al padre */
	/* display: inline-block; */
	/* vertical-align: middle; */
	box-shadow: 3px 3px 5px 3px rgba(0, 0, 0, 0.3);

	/* aplicamos un skew lo que hace skew es de alguna manera jalar las esquinas superior
	e inferior en sentidos opuestos, dando como resultado una imagen adiamantada alargada, en este 
	caso lo estamos aplicando sobre el contenedor y no sobre la imagen, aunque la imagen contenida
	tambien se estirará */
	/* skew  solo con un valor es igual a skewX*/
	/* transform: skewX(20deg) skewY(20deg); */
	/* vamos solo a deformar en X así que solo le enviamos un valor en grados sin necesidad de usar skewX y skewY */
	/* el segundo valor seria eje 'y' en caso de que lo quisieramos mandar, pero se puede enviar solo uno
	que sirve para modificar x; si solo quisieramos modificar Y podriamos enviar un 0 como primer parametro y luego
	enviar el valor en el segundo parametro, o podriamos usar skewY()	 */
	transform: skew(20deg);
	/* eliminamos el overflow usando overflow hidden */
	overflow: hidden;
}

/* definimos el elemento que queramos que tenga la animación que en este caso es el div con id #customer-1,
pero ese div no es el que queremos rotar, sino su div hijo que es el contenedor de la imagen, al div con el id #customer-1
le asignamos un hover para que la animación se active al hacer hover sobre el div y no precisamente sobre la imagen, podríamos 
con esta configuración hacer hover al texto que aparece al lado del contenedor de imagen tambien y esto animaría al contenedor de imagen */
/* como la animación va dirigida al contenedor de imagen, despues del hover al id del contenedor del cliente 1, le agregamos un selector
descendiente para ahora sí seleccionar el elemento contenedor de imagen */
#customer-1:hover .testimonial__image-container {
	/* agregamos la animación que está definida al final de este css, le ponemos de duración un segundo, sin delay
	y con función de tiempo ease-out, y además definimos que al termino de la animación conservará los estilos del ultimo keyframe */
	animation: flip-customer 1s ease-out forwards;
}

.testimonial__image {
	/* width 100% para que se ajuste al padre que ya tiene el tipo inline block */
	width: 100%;
	/* agregamos este vertical align para que no se agregue un espacio
	en la parte de abajo que se ve mal, es un bug de css de los elementos inline 
	tambien se podria arreglar cambiando el display a block porque este bug es de elementos
	inline*/
	vertical-align: top;

	/* a nuestra imagen le vamos a aplicar otra transformación para con el fin de que
ocupe todo el ancho de su contenedor, y es aumentar la escala con scale, scale puede ser scale de 'x' o 'y' */
	/* scale 'x' incrementa width y 'y' incrementa height, si solo usamos scale y le mandamos un valor,
se aumentará la escala en general de 'x' */
	/* estamos tambien agregando un skew negativo de -20deg recordar que al contenedor le hicimos un skew positivo, aquí lo que estamos haciendo
es enderezar ese skew negativo aplicado al contenedor, para que el contenedor se muestre deformado, pero nuestra imagen contenida
se muestre correctamente sin deformación */
	/* si queremos aplicar scale() uniforme, podemos enviar solo un argumento, el valor por defecto
	de scaleY que es el segundo parámetro es equivalente al valor de scaleX que es el primero, dando como
	resultado que si solo enviamos un parámetro nuestro elemento se aplicará un scale equivalente para ambas coordenadas, 
	igualmente si queremos solo aplicar el valor de scaleY podemos usar scale y enviar un 0 como primer parametro
	para en segundo parametro enviar el valor que queremos modificar que es el scaleY, o tambien podemos usar alguno 
	de los otros métodos como scaleX o scaleY */
	transform: skew(-20deg) scale(1.4);
}

.testimonial__info {
	text-align: right;
	/* padding: 14px; */
	/* de nueva cuenta cambiamos tambien padding a rem para que se comporten como los 
	margenes, es decir de forma dependiente del tamaño de la fuente */
	padding: 0.9rem;
	/* display: inline-block;
	vertical-align: middle;
	width: 30%; */
}

#customer-2.testimonial {
	text-align: right;
}

#customer-2 .testimonial__info {
	text-align: left;
}

.testimonial__name {
	/* margin: 3px; */
	margin: 0.2rem;
	color: #ff5454;
	/* font-size: 2em; */
	font-size: 2rem;
}

.testimonial__subtitle {
	margin: 0;
	/* font-size: 18px; */
	/* em hereda los tamaños anteriores y los va multiplicando con los valores previos de em
	es decir si tenemos em anidados, en cada nuevo nivel donde se use em, se usará como base para la multiplicacion
	el valor anterior de em, si en un nivel al hacer la operacion de los pixeles del navegador por ejemplo considerando 
	que en un inicio 1 em son 16px, y tenemos un nivel donde asignamos 2em para un total de 32px, en niveles 
	posteriores el em usara como factor de multiplicación ese 32, por lo tanto esto podría traernos problemas
	 */
	/* font-size: 1.1em; */
	/* en la mayoria de los casos para evitar estos problemas con los tamaños de letra
	se usará rem en lugar de em, rem siempre tendrá el mismo valor de factor de multiplicación que es el que asigna el navegador */
	font-size: 1.1rem;
	color: #ccc;
}

.testimonial__subtitle a {
	color: inherit;
	text-decoration: none;
}

.testimonial__subtitle a:hover,
.testimonial__subtitle a:active {
	color: #7a7a7a;
}

.testimonial__text {
	/* margin: 3px; */
	margin: 0.2rem;
	/* estas son algunas propiedades aplicables a textos en css */
	/* con font size cambiamos el tamaño de los textos usando diferentes
	medidas */
	/* font-size: 40px; */
	/* con font variant podemos aplicar diferentes formas de mostrar el texto de nuestra fuente
	por ejemplo small-caps hará que las letras minúsculas se conviertan en mayusculas pero con el tamaño
	de las minusculas, osea que todas las letras seran mayusculas pero se notará diferencia entre las que originalmente
	eran mayusculas y las que no */
	/* font-variant: small-caps; */
	/* font stretch nos ayuda a mostrar con diferente estiramiento las fuentes, pero solo es aplicable
	a fuentes que tengan una font-face definida para mostrar el efecto, si no tiene font face no se notará diferencia,
	si sí la tiene se mostrará aplastada o estirada la letra, en caso de poner un valor que no esté en la font-face
	se tomará el más cercano que sí esté en la fontface */
	/* font-stretch: ultra-condensed; */
	/* con letter spacing podemos modificar el espacio que hay entre las letras de los textos de nuestra página */
	/* letter-spacing: 10px; */
	/* con la propiedad whitespace modificamos el comportamiento que tienen los espacios en blanco de nuestro texto
	la propiedad normal, se comporta como es por defecto,los espacios en blanco se usan para saltos de línea cuando
	el texto no cabe en su contenedor */
	/* white-space:normal; */
	/* con nowrap el texto no se desborda y por lo tanto no hay saltos de página, el texto
	siempre se mantiene igual */
	/* white-space: nowrap; */
	/* con whitepsace pre el texto se considera como que ya tiene los saltos de linea preestablecidos
	y solo salta nuevamente de linea en caracteres de saltos de linea y en elementos html como <br> */
	/* white-space: pre; */
	/* prewrap lo mismo que lo anterior pero agrega saltos de linea para rellenar los cuadros */
	/* white-space: pre-wrap; */
	/* prelinea lo mismo que lo anterior pero elimina y ajusta los espacios en blanco de modo que el texto quede justificado */
	/* white-space: pre-line; */
}

/* agregamos nuestro query para entornos de escritorio */
/* agregamos margenes a nuestros contenedores donde esta la imagen y el nombre, 
los margenes laterales seran auto para que se centre, el ancho será fijo para que no crezca mucho en
pantallas muy grandes */
@media (min-width: 40rem) {
	.testimonial {
		margin: 3rem auto;
		max-width: 1500px;
		/* para nuestros elementos de la página de customers
		vamos a usar flex envez de inline-block, para que esten alineados verticalmente
		al usar flex usamos align items, para distribuir el contenido a lo largo
		del eje horizontal usamos space-around, de este modo nuestro contenedor
		flex se asegura que los elementos tengan el mismo espacio a los lados */
		display: flex;
		align-items: center;
		justify-content: space-around;
	}
	/* el contenedor de nuestra imagen será ahora inlineblock para que esten en la misma linea
	la imagen y el nombre del cliente, alineamos verticalmente al centro para que texto e imagen
	estén al mismo nivel, y asignamos un ancho de 66%, lo hacemos de esta medida porque estamos usando inline
	block y estamos usando salto de linea, ese salto de linea cuenta como un espacio en los elementos
	inline, por lo que para que queden en la misma linea reducimos el ancho a 69% de modo
	que ese 1% se use para el espacio extra  */
	.testimonial__image-container {
		/* eliminamos del contenedor de imagen y del contenedor de información
		el inline block y el vertical align, porque ahora lo manejará flexbox */
		/* display: inline-block;
		vertical-align: middle; */
		width: 69%;
	}
	/* para la informacion de nuestro testimonio igual asignamos inline block para que se muestre al lado
	de la imagen, alineamos verticalmente al centro y definimos un ancho porcentual que sumado
	con nuestra imagen de menos de 100% para que se muestren una al lado de la otra */
	.testimonial__info {
		/* display: inline-block;
		vertical-align: middle; */
		width: 30%;
	}
}

/* vamos a definir una animación para voltear en el eje Y, osea horizontalmente, uno de nuestros
contenedores de imagen de nuestros clientes (en este caso será el primer contenedor),
para esto como sabemos, debemos definir los keyframes o pasos
que tendrá la animación; declaramos la animación y le ponemos el nombre que queremos que tenga, y definimos los pasos */
@keyframes flip-customer {
	/* podemos tambien indicar los pasos como porcentajes, en este caso tendremos 3 pasos así 
	que los asignamos al 0% 50% y 100% de la animación, de este modo nos aseguramos que no importa la función de tiempo usada
	siempre en estas marcas de tiempo se tendrá el resultado esperado en cada una, como vamos a rotar horizontalmente rotamos en el eje Y, 
	y como queremos dar una vuelta completa, al 50% le asignamos que gire el eje 'Y' 180 grados, lo que haría que en este punto
	se esté mostrando la parte de atrás del contenedor, y hacemos que en el 100% se este girado 360 grados, lo que haría que la animación
	termine con el elemento ya habiendo rotado por completo en el eje Y, listo para otra rotación en caso de que así lo necesitemos */
	0% {
		/* estamos definiendo un skew de 20grados porque es el que está asignado al elemento previamente antes de que
		comience en él la animación y aquí al estar asignando un transform, lo estaríamos sobreescribiendo y eliminando 
		en cada paso de la animación, por eso debemos redeclararlo para que  no se pierda, ya que declarar de nuevo el valor 
		del atributo transform, borra todos los ya aplicados de transform anteriores. */
		transform: rotateY(0) skew(20deg);
	}
	50% {
		transform: rotateY(180deg) skew(20deg);
	}
	100% {
		transform: rotateY(360deg) skew(20deg);
	}
}
